#include "cMain.h"
#include <wx/clipbrd.h>
using namespace std;

wxBEGIN_EVENT_TABLE(cMain, wxFrame)//array of events. 
    EVT_BUTTON(4, OnRunClick)//When item 4(mRun) is clicked, run OnRunClick
    EVT_BUTTON(5, OnClearClick)
    EVT_CHAR_HOOK(OnKeyDown)//When a key is pressed, run OnKeyDown
wxEND_EVENT_TABLE()

cMain::cMain() : wxFrame(nullptr, wxID_ANY, "Random LFOer", 
    wxPoint(300, 300), wxSize(275, 425))
{//Creates text entries, then a button and a list of generated LFOs

    mAuthor = new wxTextCtrl(this, 1, "Your Name", 
        wxPoint(50, 10), wxSize(200, 20));
    mAuthorTxt = new wxStaticText(this, wxID_ANY, "Author:", 
        wxPoint(10, 10));

    mName = new wxTextCtrl(this, 2, "Crazy Random LFO!", 
        wxPoint(50, 40), wxSize(200, 20));
    mNameTxt = new wxStaticText(this, wxID_ANY, "Name:", 
        wxPoint(10, 40));

    mPoints = new wxTextCtrl(this, 3, "10", 
        wxPoint(50, 70), wxSize(200, 20));
    mPointsTxt = new wxStaticText(this, wxID_ANY, "Points:", 
        wxPoint(10, 70));

    mRun = new wxButton(this, 4, "Generate", 
        wxPoint(10, 100), wxSize(150, 20));
    mClear = new wxButton(this, 5, "Clear", 
        wxPoint(10, 130), wxSize(150, 20));
    mText = new wxStaticText(this, 6, "Select and press Enter to copy:", 
        wxPoint(10, 155));
    mLFOs = new wxListBox(this, 7, 
        wxPoint(10, 175), wxSize(2400, 200));
}

cMain::~cMain(){ }

void cMain::OnClearClick(wxCommandEvent& evt) {mLFOs->Clear(); cMain::currentCopy = -1;}

void cMain::OnRunClick(wxCommandEvent& evt)
{//When the button is clicked, do this. 
    int power_disp = 0.6;
    int point_disp = 1.1;
    string LFO;
    while (true)
    {
        LFO = cMain::generateRandomLFO(
            std::string(mAuthor->GetValue()), std::string(mName->GetValue()),
            wxAtoi(mPoints->GetValue()), power_disp, point_disp);
        if (mLFOs->FindString(LFO) == wxNOT_FOUND) {break;}
    }
    mLFOs->AppendString(LFO);
    evt.Skip();
}

void cMain::OnKeyDown(wxKeyEvent& evt)
{
    if (evt.GetKeyCode() == 13)
    {
        if (mLFOs->GetSelection() == wxNOT_FOUND or mLFOs->GetSelection() == cMain::currentCopy)
        {
            mLFOs->AppendString(cMain::generateRandomLFO(
                std::string(mAuthor->GetValue()), std::string(mName->GetValue()),
                wxAtoi(mPoints->GetValue()), 0.6, 1.1));
        }
        else
        {
            cMain::currentCopy = mLFOs->GetSelection();
            wxString CopyLFO = mLFOs->GetString(cMain::currentCopy);
            if (wxTheClipboard->Open())
            {
                wxTheClipboard->SetData(new wxTextDataObject(std::string(CopyLFO)));
                wxTheClipboard->Close();
            }
            mLFOs->SetString(cMain::currentCopy, "Copied!");
            clock_t strt = clock() + CLOCKS_PER_SEC/2;
            while (clock() < strt) {}
            mLFOs->SetString(cMain::currentCopy, CopyLFO);
        }
    }
    evt.Skip();
}

std::string cMain::generateRandomLFO(string(author), string(name), 
    int(points), int(powerDisp), int(pointDisp))
{
    short sPos = getRand(100)/100;
    string LFO = "{\"author\":\"" + author + "\",\"name\":\"" + name +
        "\",\"num_points\":" + to_string(points+2) +
        ",\"points\":[0.0, " + to_string(sPos) + ", " + to_string(1/float(points+1)) + ", ";
    for (int n = 1; n <= points; n++)
    {
        LFO.append(to_string(getRand(100)/100) + ", ");
        LFO.append(to_string(float(n+1) / (points+1)) + ", ");
    }
    LFO.append(to_string(sPos) + "],\"powers\":[");

    for (int n = 0; n <= points; n++)
    {
        LFO.append(to_string(getRand(20)) + ", ");
    }

    LFO.append(to_string(getRand(20)) + "],\"smooth\":");
    if (rand() % 2 == 1)
    {
        LFO.append("true}");
    }
    else
    {
        LFO.append("false}");
    }

    return LFO;
}

double cMain::getRand(int(limit), double(MSDisp), double(LRDisp))
{
    double random = rand() - (RAND_MAX/2);
    double GRAND_MAX = pow(pow(1.1, RAND_MAX), LRDisp) * pow(RAND_MAX, MSDisp);
    //LRDisp makes it more likely to be positive or negative
    //MSDisp makes it more likely to be closer or farther from zero
    //Use a^x^Disp for LR, and x^Disp for MS. That will then be truncated to the limit
    return (pow(pow(1.1,random),LRDisp) * pow(random,MSDisp)+(GRAND_MAX/2))/(GRAND_MAX/limit);
    //https://www.desmos.com/calculator/ppjpdzcibs if you want to see it in action
}